Index: stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/AverageBitBinaryVectorComparer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/AverageBitBinaryVectorComparer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/AverageBitBinaryVectorComparer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("Average Bit Binary Vector Comparer", "Compares two binary vectors by their average positive bit location")]
-  [StorableClass]
+  [StorableType("F782E957-3D46-40BC-B152-045F9E2BE330")]
   public sealed class AverageBitBinaryVectorComparer : Item, IBinaryVectorComparer {
     [StorableConstructor]
-    private AverageBitBinaryVectorComparer(bool deserializing) : base(deserializing) { }
+    private AverageBitBinaryVectorComparer(StorableConstructorFlag _) : base(_) { }
     private AverageBitBinaryVectorComparer(AverageBitBinaryVectorComparer original, Cloner cloner)
       : base(original, cloner) { }
Index: stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/IBinaryVectorComparer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/IBinaryVectorComparer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/IBinaryVectorComparer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,6 +23,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
+  [StorableType("056C41CB-BF99-418E-AAF5-85273EF0831A")]
   public interface IBinaryVectorComparer : IItem, IComparer<BinaryVector> { }
 }
Index: stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/LexicographicBinaryVectorComparer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/LexicographicBinaryVectorComparer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/LexicographicBinaryVectorComparer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("Lexicographic Binary Vector Comparer", "Compares two binary vectors lexicographically")]
-  [StorableClass]
+  [StorableType("E107BAC1-B863-4704-9129-F258B0974285")]
   public sealed class LexicographicBinaryVectorComparer : Item, IBinaryVectorComparer {
     [StorableConstructor]
-    private LexicographicBinaryVectorComparer(bool deserializing) : base(deserializing) { }
+    private LexicographicBinaryVectorComparer(StorableConstructorFlag _) : base(_) { }
     private LexicographicBinaryVectorComparer(LexicographicBinaryVectorComparer original, Cloner cloner)
       : base(original, cloner) { }
Index: stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/MedianBitBinaryVectorComparer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/MedianBitBinaryVectorComparer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/BinaryVectorComparers/MedianBitBinaryVectorComparer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("Median Bit Binary Vector Comparer", "Compares two binary vectors by the median positive bit location")]
-  [StorableClass]
+  [StorableType("C750F13C-F775-4A53-8725-DB26F38DC229")]
   public sealed class MedianBitBinaryVectorComparer : Item, IBinaryVectorComparer {
     [StorableConstructor]
-    private MedianBitBinaryVectorComparer(bool deserializing) : base(deserializing) { }
+    private MedianBitBinaryVectorComparer(StorableConstructorFlag _) : base(_) { }
     private MedianBitBinaryVectorComparer(MedianBitBinaryVectorComparer original, Cloner cloner)
       : base(original, cloner) { }
Index: stable/HeuristicLab.Problems.NK/3.3/HeuristicLab.Problems.NK-3.3.csproj
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/HeuristicLab.Problems.NK-3.3.csproj	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/HeuristicLab.Problems.NK-3.3.csproj	(revision 17097)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Problems.NK</RootNamespace>
     <AssemblyName>HeuristicLab.Problems.NK-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <TargetFrameworkProfile />
@@ -109,7 +109,16 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="Google.Protobuf, Version=3.6.1.0, Culture=neutral, PublicKeyToken=a7d26565bac4d604, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\Google.Protobuf.3.6.1\lib\net45\Google.Protobuf.dll</HintPath>
+    </Reference>
+    <Reference Include="HEAL.Attic, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\HEAL.Attic.1.0.0-pre02\lib\net461\HEAL.Attic.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Drawing.Common, Version=4.0.0.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\System.Drawing.Common.4.5.1\lib\net461\System.Drawing.Common.dll</HintPath>
+    </Reference>
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -144,4 +153,5 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
+    <None Include="packages.config" />
     <None Include="Plugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
Index: stable/HeuristicLab.Problems.NK/3.3/INKMoveEvaluator.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/INKMoveEvaluator.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/INKMoveEvaluator.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Optimization;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
+  [StorableType("06B5D234-4D97-4D4A-8EE2-E61FB21A54F6")]
   public interface INKMoveEvaluator : ISingleObjectiveMoveEvaluator, IMoveOperator { }
 }
Index: stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IInteractionInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IInteractionInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IInteractionInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
+  [StorableType("78325D81-C6B0-49FF-B190-755B7D413E56")]
   public interface IInteractionInitializer : IParameterizedItem {
     BoolMatrix InitializeInterations(int length, int nComponents, int nInteractions, IRandom random);
Index: stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,12 +26,12 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("IncreasingBlockSizeInteractionsInitializer", "Randomly assignes interactions across all bits but makes sure that different numbers of ineractions are applied to different bits.")]
-  [StorableClass]
+  [StorableType("E4AAEDCA-6A90-45AE-AFD5-B200A50ACAB8")]
   public sealed class IncreasingBlockSizeInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
     [StorableConstructor]
-    private IncreasingBlockSizeInteractionsInitializer(bool serializing) : base(serializing) { }
+    private IncreasingBlockSizeInteractionsInitializer(StorableConstructorFlag _) : base(_) { }
     private IncreasingBlockSizeInteractionsInitializer(IncreasingBlockSizeInteractionsInitializer original, Cloner cloner) : base(original, cloner) { }
     public IncreasingBlockSizeInteractionsInitializer() { }
Index: stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/LimitedRandomInteractionsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/LimitedRandomInteractionsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/LimitedRandomInteractionsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,9 +26,9 @@
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("LimitedRandomInteractionsInitializer", "Randomly assignes interactions across bits in the vicinity of each other respecting the maximum distances if possible.")]
-  [StorableClass]
+  [StorableType("A49E3167-FC04-40F8-A45C-BA8818CE2065")]
   public sealed class LimitedRandomInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
     private class Bounds {
@@ -52,5 +52,5 @@
 
     [StorableConstructor]
-    private LimitedRandomInteractionsInitializer(bool serializing) : base(serializing) { }
+    private LimitedRandomInteractionsInitializer(StorableConstructorFlag _) : base(_) { }
     private LimitedRandomInteractionsInitializer(LimitedRandomInteractionsInitializer original, Cloner cloner) : base(original, cloner) { }
     public LimitedRandomInteractionsInitializer() {
Index: stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/RandomInteractionsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/RandomInteractionsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/RandomInteractionsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("RandomInteractionsInitializer", "Randomly assignes interactions across all bits")]
-  [StorableClass]
+  [StorableType("ACB3BE45-DB9E-4200-95BF-D22C726B4DAE")]
   public sealed class RandomInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
     [StorableConstructor]
-    private RandomInteractionsInitializer(bool serializing) : base(serializing) { }
+    private RandomInteractionsInitializer(StorableConstructorFlag _) : base(_) { }
     private RandomInteractionsInitializer(RandomInteractionsInitializer original, Cloner cloner) : base(original, cloner) { }
     public RandomInteractionsInitializer() { }
Index: stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/SortedRandomInteractionsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,10 +26,10 @@
 using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.NK {
   [Item("SortedRandomInteractionsInitializer", "Randomly assigns interactions across all bits and sorts components according to bit affinity.")]
-  [StorableClass]
+  [StorableType("33F27348-DC65-4DCF-88EC-383379EEEA0C")]
   public sealed class SortedRandomInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
     public IConstrainedValueParameter<IBinaryVectorComparer> ComparerParameter {
@@ -41,5 +41,5 @@
 
     [StorableConstructor]
-    private SortedRandomInteractionsInitializer(bool serializing) : base(serializing) { }
+    private SortedRandomInteractionsInitializer(StorableConstructorFlag _) : base(_) { }
     private SortedRandomInteractionsInitializer(SortedRandomInteractionsInitializer original, Cloner cloner) : base(original, cloner) { }
     public SortedRandomInteractionsInitializer() {
Index: stable/HeuristicLab.Problems.NK/3.3/NKBitFlipMoveEvaluator.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/NKBitFlipMoveEvaluator.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/NKBitFlipMoveEvaluator.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,10 +26,10 @@
 using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
 
   [Item("NK BitFlip Move Evaluator", "Evaluates a single bit flip on an NK landscape.")]
-  [StorableClass]
+  [StorableType("58DA2DE8-6FEB-464F-9B25-E2CA676D530E")]
   public class NKBitFlipMoveEvaluator : NKMoveEvaluator, IOneBitflipMoveOperator {
     public ILookupParameter<OneBitflipMove> OneBitflipMoveParameter {
@@ -41,5 +41,5 @@
 
     [StorableConstructor]
-    protected NKBitFlipMoveEvaluator(bool deserializing) : base(deserializing) { }
+    protected NKBitFlipMoveEvaluator(StorableConstructorFlag _) : base(_) { }
     protected NKBitFlipMoveEvaluator(NKBitFlipMoveEvaluator original, Cloner cloner)
       : base(original, cloner) { }
Index: stable/HeuristicLab.Problems.NK/3.3/NKLandscape.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/NKLandscape.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/NKLandscape.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,5 +28,5 @@
 using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Problems.Binary;
@@ -36,5 +36,5 @@
   [Item("NK Landscape", "Represents an NK landscape optimization problem.")]
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 215)]
-  [StorableClass]
+  [StorableType("04294537-87F2-4A9F-BC14-7D4CA700F326")]
   public sealed class NKLandscape : BinaryProblem {
     public override bool Maximization {
@@ -136,5 +136,5 @@
 
     [StorableConstructor]
-    private NKLandscape(bool deserializing) : base(deserializing) { }
+    private NKLandscape(StorableConstructorFlag _) : base(_) { }
     private NKLandscape(NKLandscape original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/NKMoveEvaluator.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/NKMoveEvaluator.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/NKMoveEvaluator.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,10 +26,10 @@
 using HeuristicLab.Operators;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
 
   [Item("NKMoveEvaluator", "A base class for operators which evaluate moves on the NK Landscape.")]
-  [StorableClass]
+  [StorableType("54E33987-5AC1-4E3B-ABE7-769B009A6A76")]
   public abstract class NKMoveEvaluator : SingleSuccessorOperator, INKMoveEvaluator, IBinaryVectorMoveOperator {
 
@@ -56,5 +56,5 @@
 
     [StorableConstructor]
-    protected NKMoveEvaluator(bool deserializing) : base(deserializing) { }
+    protected NKMoveEvaluator(StorableConstructorFlag _) : base(_) { }
     protected NKMoveEvaluator(NKMoveEvaluator original, Cloner cloner) : base(original, cloner) { }
     protected NKMoveEvaluator()
Index: stable/HeuristicLab.Problems.NK/3.3/Plugin.cs.frame
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/Plugin.cs.frame	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/Plugin.cs.frame	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: stable/HeuristicLab.Problems.NK/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/Properties/AssemblyInfo.cs.frame	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/Properties/AssemblyInfo.cs.frame	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/EqualWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/EqualWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/EqualWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,12 +23,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("EqualWeightsInitializer", "Initializes all weights to 1.0.")]
-  [StorableClass]
+  [StorableType("AFFF8CCF-FF3E-48F6-861D-2A5E595FA0C0")]
   public sealed class EqualWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     [StorableConstructor]
-    private EqualWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private EqualWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private EqualWeightsInitializer(EqualWeightsInitializer original, Cloner cloner)
       : base(original, cloner) { }
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialDistributionWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialDistributionWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialDistributionWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,9 +26,9 @@
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("ExponentialDistributionWeightsInitializer", "Assigns exponentially decreasing weights using the rate parameter lambda.")]
-  [StorableClass]
+  [StorableType("F67982B7-A94B-4876-977A-34DB44B40739")]
   public sealed class ExponentialDistributionWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     public IValueParameter<DoubleValue> LambdaParameter {
@@ -37,5 +37,5 @@
 
     [StorableConstructor]
-    private ExponentialDistributionWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private ExponentialDistributionWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private ExponentialDistributionWeightsInitializer(ExponentialDistributionWeightsInitializer original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ExponentialWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("ExponentialWeightsInitializer", "Assigns exponentially increasing weights.")]
-  [StorableClass]
+  [StorableType("6F927828-8292-49E6-95CB-F4CFA97018CA")]
   public sealed class ExponentialWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     [StorableConstructor]
-    private ExponentialWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private ExponentialWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private ExponentialWeightsInitializer(ExponentialWeightsInitializer original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/IWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/IWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/IWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -22,6 +22,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
+  [StorableType("5F374919-37B0-4FB0-B07D-C3136970EA37")]
   public interface IWeightsInitializer : IParameterizedItem {
     IEnumerable<double> GetWeights(int nComponents);
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/LinearWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/LinearWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/LinearWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,12 +23,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("LinearWeightsInitializer", "Assigns linear increasing weights.")]
-  [StorableClass]
+  [StorableType("355BD81C-E35B-4260-91DD-2B1729682E61")]
   public sealed class LinearWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     [StorableConstructor]
-    private LinearWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private LinearWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private LinearWeightsInitializer(LinearWeightsInitializer original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseExponentialWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseExponentialWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseExponentialWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,12 +24,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("ReverseExponentialWeightsInitializer", "Assigns exponentially decreasing weights.")]
-  [StorableClass]
+  [StorableType("DF84DB40-3B0D-4047-ABAC-4962D970A08A")]
   public sealed class ReverseExponentialWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     [StorableConstructor]
-    private ReverseExponentialWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private ReverseExponentialWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private ReverseExponentialWeightsInitializer(ReverseExponentialWeightsInitializer original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseLinearWeightsInitializer.cs
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseLinearWeightsInitializer.cs	(revision 15587)
+++ stable/HeuristicLab.Problems.NK/3.3/WeightInitializers/ReverseLinearWeightsInitializer.cs	(revision 17097)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,12 +23,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.NK {
   [Item("ReverseLinearWeightsInitializer", "Assigns exponentially decreasing weights.")]
-  [StorableClass]
+  [StorableType("E63DE1AE-FBA4-4430-9C22-631ADDFD3976")]
   public sealed class ReverseLinearWeightsInitializer : ParameterizedNamedItem, IWeightsInitializer {
     [StorableConstructor]
-    private ReverseLinearWeightsInitializer(bool deserializing) : base(deserializing) { }
+    private ReverseLinearWeightsInitializer(StorableConstructorFlag _) : base(_) { }
     private ReverseLinearWeightsInitializer(ReverseLinearWeightsInitializer original, Cloner cloner)
       : base(original, cloner) {
Index: stable/HeuristicLab.Problems.NK/3.3/packages.config
===================================================================
--- stable/HeuristicLab.Problems.NK/3.3/packages.config	(revision 17097)
+++ stable/HeuristicLab.Problems.NK/3.3/packages.config	(revision 17097)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<packages>
+  <package id="Google.Protobuf" version="3.6.1" targetFramework="net461" />
+  <package id="HEAL.Attic" version="1.0.0-pre02" targetFramework="net461" />
+  <package id="System.Drawing.Common" version="4.5.1" targetFramework="net461" />
+</packages>